Public Class Form1

    Dim WithEvents serialPort As New IO.Ports.SerialPort
    Dim PortAChaserReadFlag As Boolean
    

    Dim IStep As Byte
    Dim pos As Byte
    Dim IOVALA As Integer



    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'Initialise variables that are being used
        '
        PortAChaserReadFlag = False
        Timer1.Enabled = True

        For i As Integer = 0 To _
           My.Computer.Ports.SerialPortNames.Count - 1
            ComboBox1.Items.Add(My.Computer.Ports.SerialPortNames(i))
        Next
        btnDisconnect.Enabled = False

    End Sub

    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click


        If serialPort.IsOpen Then
            serialPort.Close()
        End If

        Try
            With serialPort
                .PortName = ComboBox1.Text
                .BaudRate = 115200
                .Parity = IO.Ports.Parity.None
                .DataBits = 8
                .StopBits = IO.Ports.StopBits.One
            End With
            serialPort.Open()

            lblMessage.Text = ComboBox1.Text & " connected."
            btnConnect.Enabled = False
            btnDisconnect.Enabled = True
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    Private Sub btnDisconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisconnect.Click
        Try
            serialPort.Close()
            lblMessage.Text = serialPort.PortName & " disconnected."
            btnConnect.Enabled = True
            btnDisconnect.Enabled = False
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        serialPort.Write("!A" & Chr(0))
    End Sub

    Private Sub Button50_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button50.Click
        Dim buffer As Byte() = {&HFF}
        serialPort.Write("A")
        serialPort.Write(buffer, 0, 1) '("B" & Chr(0))
    End Sub

    Private Sub Button51_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button51.Click
        'Dim buffer As Byte()
        

        Dim buffer As Byte() = {&H0}
        serialPort.Write("A")
        serialPort.Write(buffer, 0, 1) '("B" & Chr(0))
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim myhex As Byte() = {&H0}

        If PortAChaserReadFlag = True Then

            pos = IStep
            If IStep > 7 Then pos = 14 - IStep
            serialPort.Write("A")
            myhex(0) = (2 ^ pos)
            serialPort.Write(myhex, 0, 1)
            IStep = IStep + 1
            If IStep = 14 Then IStep = 0
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        If PortAChaserReadFlag = True Then
            serialPort.Write("!A" & Chr(&H0))
            'Timer3.Enabled = True
            PortAChaserReadFlag = False
            Exit Sub
        End If
        If PortAChaserReadFlag = False Then
            'Timer3.Enabled = False
            PortAChaserReadFlag = True
            Exit Sub
        End If
    End Sub

    Private Sub Button52_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button52.Click
        Dim buffer As Byte() = {&H55}
        serialPort.Write("A")
        serialPort.Write(buffer, 0, 1) '("B" & Chr(0))
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim myData As Integer
        Dim ascChar As String

        serialPort.Write("a")
        ' Wait some time for response
        System.Threading.Thread.Sleep(50)

        If serialPort.BytesToRead = 1 Then
            myData = serialPort.ReadByte
        ElseIf serialPort.BytesToRead = 0 Then
            TextBox1.Text = "Read Timeout"
        End If

        ascChar = Conversion.Hex(myData.ToString) 'CChar(ChrW(mydata))
        TextBox1.Text = ascChar

    End Sub


    Private Sub serialPort_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles serialPort.DataReceived

        'fires when data is received in the input buffer

        If serialPort.BytesToRead > 0 Then
            Do
                myRxData(serialPort.ReadByte)
                If serialPort.BytesToRead = 0 Then
                    Exit Do
                End If
            Loop
        End If
    End Sub



    Private Sub myRxData(ByVal mydata As Integer)
        Dim ascChar As String
        'Disables errors when calling functions from different threads
        'not the best way but suitable for our purpose.....

        CheckForIllegalCrossThreadCalls = False

        'Formats data to textbox so you can see whats coming in
        'mydata.ToString()

        ascChar = Conversion.Hex(mydata.ToString) 'CChar(ChrW(mydata))
        TextBox1.Text = ascChar

    End Sub

    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged

    End Sub
End Class
